#include <stdio.h>
#include <sys/time.h>
#include <time.h>
#include <unistd.h>

double now(void)
{
	struct timeval t;
	gettimeofday(&t, NULL);
	return t.tv_sec + t.tv_usec * 1e-6;
}

int main()
{
	double t0, t, dt, max_dt = 0.0;
	char tbuf[100];
	time_t utc;

	t0 = now();
	for (;;)
	{
		t = now();
		dt = t - t0;
		if (dt > 0.008)
		{
			max_dt = dt;
			time(&utc);
			strftime(tbuf, sizeof(tbuf), "%T", localtime(&utc));
			printf("%s: dt = %.3f ms\n", tbuf, max_dt * 1e3);
			t = now();
		}
		t0 = t;
	}

	return 0;
}
